package BBUVA;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;

@Entity
public class Titular implements Serializable {

    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    private Long id;
    private String documentacion;
    private String nombre;
    @ManyToMany(mappedBy = "mTitular",cascade = CascadeType.ALL)
    private List<Producto> mProductos;

    public Titular () {
        mProductos = new ArrayList();
    }

    public String getDocumentacion () {
        return documentacion;
    }

    public void setDocumentacion (String val) {
        this.documentacion = val;
    }

    public String getNombre () {
        return nombre;
    }

    public void setNombre (String val) {
        this.nombre = val;
    }

    public List<Producto> getMProductos() {
        return mProductos;
    }

    public void setMProductos(List<Producto> val) {
        setMProductos(val);
    }

    public void addProducto(Producto val) {
        getMProductos().add(val);
    }

    @Override
    public String toString() {
        return this.getNombre();
    }

    public String descripcionBasica() {
        String cadena="";
        cadena = "Número de identificación:\n   ";
        cadena += this.getDocumentacion();
        cadena += "\n\nNombre:\n   ";
        cadena += this.getNombre();
        cadena += "\n\nNº de cuentas del titular: "+ this.mProductos.size();
        return cadena;
    }

    public String descripcion() {
        String cadena="";
        cadena =  this.descripcionBasica() + "\n\n   ";
        for(int i=0;i<this.mProductos.size();i++) {
                cadena += this.mProductos.get(i).getClass().toString().substring(12);
                cadena += "\n    "+this.mProductos.get(i).getNumeroProducto() + "      " + this.mProductos.get(i).getSaldo() + "\n   ";
        }
        if(this.mProductos.size()==0) cadena += "No tiene cuentas creadas.\n";
        return cadena;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the documentacion fields are not set
        if (!(object instanceof Titular)) {
            return false;
        }
        Titular other = (Titular) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }
}

